
#include <algo.h>
#include "BByteInputStream.h"

int BByteInputStream::read(int asize,BYTE* adata)
{
    if(asize<=0)
	return 0;

    int rest=asize;
    int readByte=0; // ɤ߹ Byte
    int bufSize=buf->size();
    if(bufSize>0) // ɤߥХåե˥ǡ
    {
	int i;

	for(i=0; i<min(asize,bufSize); i++)
	{
	    adata[i]=*(buf->begin());
	    buf->pop_front();
	    rest--; readByte++;
	}
	if(rest!=0)
	    readByte+=read_inner(rest,&adata[i]);
    }else
	readByte=read_inner(rest,&adata[0]);

    count+=readByte; // Ȥʤ
    return readByte;
}

int BByteInputStream::peek(int asize,BYTE* adata)
{
    if(asize<=0)
	return 0;

    int readByte;
    int bufSize=buf->size();
    if(bufSize<asize) // ɤߥХåեǤ­ʤ
    {
	BYTE* tmpBuf=new BYTE[asize-bufSize];
	readByte=read_inner(asize-bufSize,tmpBuf);
	for(int i=0; i<readByte; i++)
	    buf->push_back(tmpBuf[i]); // Хåեθɤߤ
	delete tmpBuf;
	copy(buf->begin(),buf->end(),adata);

	return bufSize+readByte;
    }else{
	list<BYTE>::iterator i=buf->begin();
	for(int count=0; count<asize; count++)
	{
	    adata[count]=*i;
	    i++;
	}
//	copy(buf->begin(),buf->begin()+asize,adata);
	return asize;
    }
}

int BByteInputStream::skip(int asize)
{
    int bufSize=buf->size();

    if(bufSize>=asize) // ɤߥХåե­ꤿ
    {
	for(int i=0; i<asize; i++)
	    buf->pop_front();
	count+=asize;
	return asize;
    }

    // ɤߥХåե­ʤ
    // ޤХåեʬ skip
    for(int i=0;i<bufSize; i++)
	buf->pop_front();
    count+=bufSize;

    // Τʬ stream  skip
    int skipedSize=skip_inner(asize-bufSize);
    count+=skipedSize;

    return bufSize+skipedSize;
}

int BByteInputStream::read_reverse(int asize,BYTE* adata)
{
    BYTE* buf=new BYTE[asize];

    int ret=read(asize,buf);
    for(int i=0; i<asize; i++)
	adata[i]=buf[asize-i-1];

    delete buf;
    return ret;
}


bool BByteInputStream::read(SBYTE& adata)
{
    if(read(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}
bool BByteInputStream::read(BYTE& adata)
{
    if(read(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}

#ifdef BIG_ENDIAN_SYSTEM

bool BByteInputStream::read(DBYTE& adata)
{
    if(read_reverse(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}
bool BByteInputStream::read(UDBYTE& adata)
{
    if(read_reverse(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}
bool BByteInputStream::read(QBYTE& adata)
{
    if(read_reverse(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}
bool BByteInputStream::read(UQBYTE& adata)
{
    if(read_reverse(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}

#else

bool BByteInputStream::read(DBYTE& adata)
{
    if(read(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}
bool BByteInputStream::read(UDBYTE& adata)
{
    if(read(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}
bool BByteInputStream::read(QBYTE& adata)
{
    if(read(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}
bool BByteInputStream::read(UQBYTE& adata)
{
    if(read(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}

#endif

bool BByteInputStream::read(POINT& adata)
{
    if(!read(adata.h))
	return false;
    if(!read(adata.v))
	return false;
    return true;
}

bool BByteInputStream::read(RECT& adata)
{
    if(!read(adata.left))
	return false;
    if(!read(adata.top))
	return false;
    if(!read(adata.right))
	return false;
    if(!read(adata.bottom))
	return false;
    return true;
}
