// -*- C++ -*-
#ifndef BByteOutputStream_h
#define BByteOutputStream_h

#include "BTADType.h"

class BByteOutputStream
{
    int count;

protected:
    // BByteOutputStream p write_inner Ȃ΂ȂȂ
    virtual int write_inner(int asize,BYTE* adata)=0;
    int write_reverse(int asize,BYTE* adata);

public:
    BByteOutputStream() : count(0) {}

    int getCount() const { return count; }
    void resetCount() { count=0; }

    int write(int asize,BYTE* adata);

    bool write(SBYTE adata);
    bool write(BYTE adata);
    bool write(DBYTE adata);
    bool write(UDBYTE adata);
    bool write(QBYTE adata);
    bool write(UQBYTE adata);
    bool write(POINT adata);
    bool write(RECT adata);
};

#endif
