#include "BFigSeg.h"
#include "BByteInputStream.h"
#include "BByteOutputStream.h"

BFigSeg::BFigSeg():
BSegment(TS_FIG)
{
}

bool BFigSeg::readData(BByteInputStream* ain,UQBYTE alength)
{
    if(!ain->read(view))
	return false;
    if(!ain->read(draw))
	return false;
    if(!ain->read(h_unit))
	return false;
    if(!ain->read(v_unit))
	return false;
    if(!ain->read(reserv))
	return false;

    return true;
}

bool BFigSeg::writeData(BByteOutputStream* aout) const
{
    if(!aout->write(view))
	return false;
    if(!aout->write(draw))
	return false;
    if(!aout->write(h_unit))
	return false;
    if(!aout->write(v_unit))
	return false;
    if(!aout->write(reserv))
	return false;

    return true;
}
