#include "BSegment.h"
#include "BByteInputStream.h"
#include "BByteOutputStream.h"

BSegment::BSegment(BYTE aID,BYTE asubID):
ID(aID),subID(asubID)
{
}

BSegment::BSegment(BYTE aID):
ID(aID),subID(TSS_NONE)
{
}

bool BSegment::readSubID(BByteInputStream* ain)
{
    BYTE sub;
    if(!(ain->read(attr)))
	return false;
    if(!(ain->read(sub)) || sub!=subID)
	return false;
    return true;
}

bool BSegment::writeSubID(BByteOutputStream* aout) const
{
    if(!(aout->write(attr)))
	return false;
    if(!(aout->write(subID)))
	return false;
    return true;
}
