#include "BSegmentMaker.h"
#include "BUnknownSeg.h"

BSegmentMaker defaultSegMaker;	// ǥեȤ segment maker
				//  BSegment Υ֥饹ϿƤ

bool BSegmentMaker::regist(BYTE aID,BSegment* (*amaker)() )
{
    if(IDTable.count(aID)==0)
    { // ޤϿƤʤä
	IDTable.insert(map<BYTE,IDInfo,less<BYTE> >::value_type(aID,IDInfo())); // IDTable ɲ
	IDTable[aID].maker=amaker;
    }else{
	if(IDTable[aID].maker!=NULL)
	    IDTable[aID].maker=amaker; // ϿΤ񤭤
	else // Ǥ sub ID դϿƤ
	    return false;
    }
    return true;
}

bool BSegmentMaker::regist(BYTE aID,BYTE asubID,BSegment* (*amaker)() )
{
    if(IDTable.count(aID)==0)
    { // ޤϿƤʤä
	IDTable[aID]; // IDTable ɲ
	IDTable[aID].maker=NULL;
	IDTable[aID].subIDTable[asubID]=amaker;
    }else{
	if(IDTable[aID].maker==NULL)
	    IDTable[aID].subIDTable[asubID]=amaker; // ϿΤ񤭤
	else // Ǥ sub ID ʤϿƤ
	    return false;
    }
    return true;
}

bool BSegmentMaker::hasSubID(BYTE aID)
{
    if(IDTable.count(aID)==1)
    {
	if(IDTable[aID].maker==NULL)
	    return true;
    }
    return false;
}

bool BSegmentMaker::isRegisted(BYTE aID) const
{
    if(IDTable.count(aID)!=0)
	return true;
    else
	return false;
}

BSegment* BSegmentMaker::make(BYTE aID)
{
    if(!hasSubID(aID) && IDTable[aID].maker!=NULL)
	return IDTable[aID].maker();
    else
	return new BUnknownSeg(aID);
}

BSegment* BSegmentMaker::make(BYTE aID,BYTE asubID)
{
    if(hasSubID(aID) && IDTable[aID].subIDTable.count(asubID)==1)
	return IDTable[aID].subIDTable[asubID]();
    else
	return new BUnknownSeg(aID);
}
