#ifndef BSegmentMaker_h
#define BSegmentMaker_h

// ID,sub ID ˹äȤ륻ȥ᡼

#include "BTADType.h"
#include <map.h>

class BSegment;

class BSegmentMaker
{
    struct IDInfo {
	map<BYTE,BSegment* (*)(),less<BYTE> > subIDTable;
	BSegment* (*maker)();	// maker= null: sub ID 
				// maker!=null: sub ID ʤ
	IDInfo():maker(NULL){}
    };
    map<BYTE,IDInfo,less<BYTE> > IDTable;

public:
    bool regist(BYTE aID,BSegment* (*amaker)() );
    bool regist(BYTE aID,BYTE asubID,BSegment* (*amaker)() );
    bool hasSubID(BYTE aID); // sub ID ĥȤɤ
    bool isRegisted(BYTE aID) const;  // ϿƤ뤫ɤ
    BSegment* make(BYTE aID);
    BSegment* make(BYTE aID,BYTE asubID);
};

// ǥեȤΥȥ᡼
// ̤Ϥ˥ȤϿ
extern BSegmentMaker defaultSegMaker;
// (ȼΥȥ᡼äƤɤ)

#endif
