#include "BUnknownSeg.h"
#include "BByteInputStream.h"
#include "BByteOutputStream.h"

BUnknownSeg::BUnknownSeg(BYTE aID):
BSegment(aID),data(NULL),length(0)
{
}

bool BUnknownSeg::readData(BByteInputStream* ain,UQBYTE alength)
{
    if(data!=NULL)
	delete data;
    data=new BYTE[alength];
    length=alength;

    if(ain->read(length,data)==length)
	return true;
    else
	return false;
}

bool BUnknownSeg::writeData(BByteOutputStream* aout) const
{
    if(data==NULL)
	return false;
    if(aout->write(length,data)!=length)
	return false;
    return true;
}
