#include <iostream.h>
#include "OstreamOutputStream.h"
#include "BTADOutputHelper.h"

OstreamByteOutputStream::OstreamByteOutputStream(ostream& aout):
out(aout)
{
}

int OstreamByteOutputStream::write_inner(int asize,BYTE* adata)
{
    out.write(adata,asize);
    if(!out)
	return 0;
    else
	return asize;
}



OstreamTADOutputStream::OstreamTADOutputStream(ostream& aout)
{
    out=new OstreamByteOutputStream(aout);
    helper=new BTADOutputHelper(out);
}

OstreamTADOutputStream::~OstreamTADOutputStream()
{
    delete helper;
    delete out;
}

bool OstreamTADOutputStream::putSegment(const BSegment* asegment)
{
    return helper->putSegment(asegment);
}
