// -*- C++ -*-
#ifndef OstreamOutputStream_h
#define OstreamOutputStream_h

#include "BByteOutputStream.h"

class ostream;

// C++ $BI8=`$N(B iostream $B$r%i%C%T%s%0$7$?$b$N(B
class OstreamByteOutputStream : public BByteOutputStream
{
    ostream& out;
protected:
    virtual int write_inner(int asize,BYTE* adata);
public:
    OstreamByteOutputStream(ostream& aout);

};

#include "BTADOutputStream.h"

class BTADOutputHelper;

class OstreamTADOutputStream : public BTADOutputStream
{
    OstreamByteOutputStream* out;
    BTADOutputHelper* helper;
public:
    OstreamTADOutputStream(ostream& aout);
    ~OstreamTADOutputStream();
    bool putSegment(const BSegment* asegment);
};

#endif
