#include <iostream.h>
#include "BSegmentMaker.h"
#include "IstreamInputStream.h"
#include "BInfoSeg.h"


void main()
{
    BSegMakerRegister<BInfoSeg,TS_INFO> InfoReg;

    if(defaultSegMaker.isRegisted(TS_INFO))
	cout << "yes" << endl;
    else
	cout << "no" << endl;

    BInfoSeg* info=(BInfoSeg*)defaultSegMaker.make(TS_INFO);

    if(info==NULL)
	cout << "NULL" << endl;
    else
	cout << "not NULL" << endl;

    cout << "ID=" << (int)(info->getID()) << endl;
    cout << "Length=" << info->getLength() << endl;
    cout << "version=" << info->getVersion() << endl;

    info->setVersion(0x121);

    cout << "ID=" << (int)(info->getID()) << endl;
    cout << "Length=" << info->getLength() << endl;
    cout << "version=" << info->getVersion() << endl;

    delete info;
}
