// -*- C++ -*-
#ifndef BByteInputStream_h
#define BByteInputStream_h

#include "BTADType.h"
#include <list.h>

#include <iostream.h>

class BByteInputStream
{
private:
    list<BYTE>* buf;
    int count;

protected:
    // BByteInputStream Ѿ顢2ĤʤФʤʤ
    virtual int read_inner(int asize,BYTE* adata)=0;
    virtual int skip_inner(int asize)=0;

    int read_reverse(int asize,BYTE* adata);

public:
    BByteInputStream() : count(0),buf(new list<BYTE>) {}
    ~BByteInputStream() { delete buf; }

    int getCount() const { return count; }
    void resetCount() { count=0; }

    int read(int asize,BYTE* adata);
    int peek(int asize,BYTE* adata);
    int skip(int asize);

    bool read(SBYTE& adata);
    bool read(BYTE& adata);
    bool read(DBYTE& adata);
    bool read(UDBYTE& adata);
    bool read(QBYTE& adata);
    bool read(UQBYTE& adata);
    bool read(POINT& adata);
    bool read(RECT& adata);
};

#endif
