#include <algo.h>
#include "BByteOutputStream.h"

int BByteOutputStream::write(int asize,BYTE* adata)
{
    if(asize<=0)
	return 0;

    int writeByte=0; // ɤ߹ Byte
    writeByte=write_inner(asize,&adata[0]);
    count+=writeByte; // Ȥʤ
    return writeByte;
}

int BByteOutputStream::write_reverse(int asize,BYTE* adata)
{
    BYTE* buf=new BYTE[asize];

    for(int i=0; i<asize; i++)
	adata[i]=buf[asize-i-1];
    int ret=write(asize,buf);

    delete buf;
    return ret;
}


bool BByteOutputStream::write(SBYTE adata)
{
    if(write(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}
bool BByteOutputStream::write(BYTE adata)
{
    if(write(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}

#ifdef BIG_ENDIAN_SYSTEM

bool BByteOutputStream::write(DBYTE adata)
{
    if(write_reverse(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}
bool BByteOutputStream::write(UDBYTE adata)
{
    if(write_reverse(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}
bool BByteOutputStream::write(QBYTE adata)
{
    if(write_reverse(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}
bool BByteOutputStream::write(UQBYTE adata)
{
    if(write_reverse(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}

#else

bool BByteOutputStream::write(DBYTE adata)
{
    if(write(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}
bool BByteOutputStream::write(UDBYTE adata)
{
    if(write(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}
bool BByteOutputStream::write(QBYTE adata)
{
    if(write(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}
bool BByteOutputStream::write(UQBYTE adata)
{
    if(write(sizeof(adata),(BYTE*)&adata)==sizeof(adata))
	return true;
    else
	return false;
}

#endif

bool BByteOutputStream::write(POINT adata)
{
    if(!write(adata.h))
	return false;
    if(!write(adata.v))
	return false;
    return true;
}

bool BByteOutputStream::write(RECT adata)
{
    if(!write(adata.left))
	return false;
    if(!write(adata.top))
	return false;
    if(!write(adata.right))
	return false;
    if(!write(adata.bottom))
	return false;
    return true;
}
