#include "BFigPrimLineSeg.h"
#include "BByteInputStream.h"
#include "BByteOutputStream.h"

BFigPrimLineSeg::BFigPrimLineSeg():
BSegment(TS_FPRIM,TSS_FPRIMLINE)
{
}

bool BFigPrimLineSeg::readData(BByteInputStream* ain,UQBYTE alength)
{
    readSubID(ain);
    if(!ain->read(l_atr))
	return false;
    if(!ain->read(l_pat))
	return false;
    if(!ain->read(start))
	return false;
    if(!ain->read(end))
	return false;

    return true;
}

bool BFigPrimLineSeg::writeData(BByteOutputStream* aout) const
{
    writeSubID(aout);
    if(!aout->write(l_atr))
	return false;
    if(!aout->write(l_pat))
	return false;
    if(!aout->write(start))
	return false;
    if(!aout->write(end))
	return false;

    return true;
}
