// -*- C++ -*-

// $B4IM}>pJs%;%0%a%s%H(B

// $BEPO?J}K!(B:
//     BSegMakerRegister<BInfoSeg,TS_INFO>();

#ifndef BInfoSeg_h
#define BInfoSeg_h

#include "BSegment.h"
#include <vector.h>

class BInfoSeg:public BSegment
{
public:
    struct BInfoSegData{ // $B9`L\%G!<%?(B
	UDBYTE subID;
	UDBYTE subLen;
	UDBYTE* data;
    };
private:
    vector< BInfoSegData > info;

public:
    BInfoSeg();
    ~BInfoSeg();
    UQBYTE getLength() const;
    bool readData(BByteInputStream* ain,UQBYTE alength);
    bool writeData(BByteOutputStream* aout) const;

    int getInfoNum() { return info.size(); }
    BInfoSegData getBInfoSegData(int aindex) { return info[aindex]; }
    void addBInfoSegData(BInfoSegData ainfo) { info.push_back(ainfo); }

    UDBYTE getVersion(); // TAD $B$N%P!<%8%g%s$rD4$Y$k!#L5$$>l9g$O(B 0 $B$,JV$k!#(B
    void setVersion(UDBYTE); // TAD $B$N%P!<%8%g%s$r%;%C%H$9$k!#(B
};

#endif
