// -*- C++ -*-
#ifndef BSegment_h
#define BSegment_h

// 
// ƤΥȤΥѡ饹

#ifdef NEEDBOOL_H
#include <bool.h>
#endif

#include "BTADType.h"
#include "BSegmentMaker.h"

#define TS_STRING 0x7e	// ³θĹȤ
						// BStringSegment  ID
#define TS_UNKNOWN 0x7f // ʥ
#define TSS_NONE 0xff // sub ID Ѥʤ

class BByteInputStream;
class BByteOutputStream;


class BSegment
{
public: // ǡʬ
    BYTE attr;

private:
    BYTE ID;
    BYTE subID; // sub ID ѤʤȤξ硢TSS_NONE

protected:
    // sub ID ΥȤξ subID  attr 
    // ɤ߽񤭤뤿Υ᥽åɡ
    // readData(),writeData() κǽ˻Ѥ롣
    bool readSubID(BByteInputStream* ain);
    bool writeSubID(BByteOutputStream* aout) const;

public:
    // 󥹥󥹲륻Ȥˤϥǥեȥ󥹥ȥ饯ɬ
    // (BUnknownSegment )
    BSegment(BYTE aID); // sub ID Τʤ
    BSegment(BYTE aID,BYTE asubID); // subID Τ륻

    BYTE getID() const { return ID; }
    BYTE getSubID() const { return subID; }
    virtual UQBYTE getLength() const =0; // ǡʬ礭

    // ǡʬɤ߹ߤ򤹤
    // : sub ID ΥȤξ硢subID  attr 
    //     ɤ߹ि readSubID() 
    //     readData() κǽ˻ѤʤФʤʤ
    virtual bool readData(BByteInputStream* ain,UQBYTE alength)=0;

    // ǡʬν񤭹ߤ򤹤
    // : sub ID ΥȤξ硢subID  attr 
    //     񤭹ि writeSubID() 
    //     writeData() κǽ˻ѤʤФʤʤ
    virtual bool writeData(BByteOutputStream* aout) const =0;
};


// BSegmentMaker ˻Ѥ륻ȤϿΤ륯饹

// sub ID ʤΥ
template <class T,BYTE ID>
class BSegMakerRegister
{
public:
    BSegMakerRegister(BSegmentMaker* amaker=&defaultSegMaker)
    {
	amaker->regist(ID,maker);
    }
    static BSegment* maker()
    {
	return new T;
    }
};

// sub ID Υ
template <class T,BYTE ID,BYTE subID>
class BSubIDSegMakerRegister
{
public:
    BSubIDSegMakerRegister(BSegmentMaker* amaker=&defaultSegMaker)
    {
	amaker->regist(ID,subID,maker);
    }
    static BSegment* maker()
    {
	return new T;
    }
};

#endif
