#include "BStringSeg.h"
#include "BByteInputStream.h"
#include "BByteOutputStream.h"

BStringSeg::BStringSeg():
BSegment(TS_STRING)
{
}

bool BStringSeg::readData(BByteInputStream* ain,UQBYTE alength)
{
    string.erase(string.begin(),string.end());// õ

    while(true)
    {
	BYTE buf[2];

	// ʸɤΥå
	if(!(ain->peek(2,buf)))
	    return false;
	if(buf[1]==0xff && 0x80<=buf[0] && buf[0]<0xfe)
	    break;

	TCODE code;
	ain->read(code);
	string.push_back(code);
    }
    string.push_back(0x0000);
    return true;
}

bool BStringSeg::writeData(BByteOutputStream* aout) const
{
    for(int i=0; i<string.size()-1; i++)
    {
	if(!(aout->write(string[i])))
	    return false;
    }

    return true;
}
