#ifndef BTADType_h
#define BTADType_h

// ƥबӥåǥä롣
//#define BIG_ENDIAN_SYSTEM

typedef char SBYTE;           /* դ 8 bit */
typedef unsigned char BYTE;   /* ̵ 8 bit */
typedef unsigned short UWORD; /* ̵16 bit */
typedef short WORD;           /* դ16 bit */
typedef int DWORD;            /* դ32 bit */
typedef unsigned int UDWORD;  /* ̵32 bit */
typedef UWORD TCODE;          /* 2Хʸ */
//typedef BYTE SCODE;           /* 1Хʸ */
//typedef BYTE CHAR;
typedef WORD DBYTE;
typedef UWORD UDBYTE;
typedef DWORD QBYTE;
typedef UDWORD UQBYTE;
typedef DWORD COLORVAL;
typedef WORD UNITS;
typedef UWORD CHSIZE;
typedef UWORD SCALE;
typedef UWORD RATIO;

/* ɸ */
typedef struct {
	DBYTE h;  /* ʿ(x) */
	DBYTE v;  /* ľ(y) */
} POINT;

/*  */
typedef struct {
	DBYTE left;
	DBYTE top;
	DBYTE right;
	DBYTE bottom;
} RECT;

#define TS_INFO 0xe0
#define TS_TEXT 0xe1
#define TS_TEXTEND 0xe2
#define TS_FIG 0xe3
#define TS_FIGEND 0xe4
#define TS_IMAGE 0xe5
#define TS_VOBJ 0xe6
#define TS_DFUSEN 0xe7
#define TS_FFUSEN 0xe8
#define TS_SFUSEN 0xe9

#define TS_TPAGE 0xa0
#define TS_TRULER 0xa1
#define TS_TFONT 0xa2
#define TS_TCHAR 0xa3
#define TS_TATTR 0xa4
#define TS_TSTYLE 0xa5
#define TS_TVAR 0xad
#define TS_TMEMO 0xae
#define TS_TAPPL 0xaf

#define TS_FPRIM 0xb0
#define TS_FDEF 0xb1
#define TS_FGRP 0xb2
#define TS_FMAC 0xb3
#define TS_FATTR 0xb4
#define TS_FPAGE 0xb5
#define TS_FMEMO 0xbe
#define TS_FAPPL 0xbf

// ޷
#define TSS_FPRIMRECT 0 // Ĺ
#define TSS_FPRIMRRECT 1 // ѴĹ
#define TSS_FPRIMOVAL 2 // ʱߥ
#define TSS_FPRIMSECTOR 3 // 
#define TSS_FPRIMCHORD 4 // ݷ
#define TSS_FPRIMPOLYGON 5 // ¿ѷ
#define TSS_FPRIMLINE 6 // ľ
#define TSS_FPRIMOVALARC 7 // ʱ߸̥
#define TSS_FPRIMPOLYLINE 8 // ޤL
#define TSS_FPRIMSPLINE 9 // 
#define TSS_FPRIMMARK 10 // ޡ󥻥
#define TSS_FPRIMSCAN 11 // Ǥտ޷

#endif
