#include "BTextSeg.h"
#include "BByteInputStream.h"
#include "BByteOutputStream.h"

BTextSeg::BTextSeg():
BSegment(TS_TEXT)
{
}

bool BTextSeg::readData(BByteInputStream* ain,UQBYTE alength)
{
    if(!ain->read(view))
	return false;
    if(!ain->read(draw))
	return false;
    if(!ain->read(h_unit))
	return false;
    if(!ain->read(v_unit))
	return false;
    if(!ain->read(lang))
	return false;
    if(!ain->read(bgpat))
	return false;

    return true;
}

bool BTextSeg::writeData(BByteOutputStream* aout) const
{
    if(!aout->write(view))
	return false;
    if(!aout->write(draw))
	return false;
    if(!aout->write(h_unit))
	return false;
    if(!aout->write(v_unit))
	return false;
    if(!aout->write(lang))
	return false;
    if(!aout->write(bgpat))
	return false;

    return true;
}
