#include <iostream.h>
#include "IstreamInputStream.h"
#include "BTADInputHelper.h"

IstreamByteInputStream::IstreamByteInputStream(istream& ain):
BByteInputStream(),in(ain)
{
}

int IstreamByteInputStream::read_inner(int asize,BYTE* adata)
{
    in.read(adata,asize);
    return in.gcount();
}

int IstreamByteInputStream::skip_inner(int asize)
{
    streampos oldPoint=in.tellg();
    in.seekg(asize,ios::cur);
    return (int)(in.tellg()-oldPoint);
}



IstreamTADInputStream::IstreamTADInputStream(istream& ain):
BTADInputStream()
{
    in=new IstreamByteInputStream(ain);
    helper=new BTADInputHelper(in);
}

IstreamTADInputStream::~IstreamTADInputStream()
{
    delete helper;
    delete in;
}

BSegment* IstreamTADInputStream::getSegment()
{
    return helper->getSegment();
}
