// -*- C++ -*-
#ifndef IstreamInputStream_h
#define IstreamInputStream_h

#include "BByteInputStream.h"

class istream;

// C++ W iostream bsO
class IstreamByteInputStream : public BByteInputStream
{
	istream& in;
protected:
	virtual int read_inner(int asize,BYTE* adata);
	virtual int skip_inner(int asize);
public:
	IstreamByteInputStream(istream& ain);

};

#include "BTADInputStream.h"

class BTADInputHelper;

class IstreamTADInputStream : public BTADInputStream
{
	IstreamByteInputStream* in;
	BTADInputHelper* helper;
public:
	IstreamTADInputStream(istream& ain);
	~IstreamTADInputStream();
	BSegment* getSegment();
};

#endif
